=== debian/changelog ===
openscad (2021.01-4build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Mar 2022 15:07:15 +0100

openscad (2021.01-4) unstable; urgency=medium

  * Backport fixes for CVE-2022-0496 and CVE-2022-0497 (Closes: #1005641).
  * Backport compile fix for CGAL 5.4 (Closes: #1005499).
  * Backport a fix for another FTBFS insid.
  * Lintians.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Sun, 13 Feb 2022 16:46:19 +0100

openscad (2021.01-3) unstable; urgency=medium

  * Merge Ubuntu fix to not recompress testsuite PNGs and break tests
    (Launchpad bug 1918445).

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Tue, 28 Sep 2021 22:26:50 +0200

openscad (2021.01-2) unstable; urgency=medium

  * Fix FTBFS with newer CGAL (Closes: #994937).
  * Make explicit the incompatibility with libqt5gui5-gles (Closes: #982358)

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Fri, 24 Sep 2021 19:10:03 +0200

openscad (2021.01-1) unstable; urgency=medium

  * New upstream version, official release.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Sun, 31 Jan 2021 21:17:33 +0100

openscad (2021.01~RC6-1) experimental; urgency=medium

  * New upstream version.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Wed, 20 Jan 2021 22:41:26 +0100

openscad (2019.05-5) unstable; urgency=medium

  * Package officially adopted by Kristian Nielsen, as agreed with previous
    maintainer Christian M. Amsüss.
  * Fix a mistake in debian/rules breaking the binary-indep target.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Thu, 07 Jan 2021 12:49:07 +0100

openscad (2019.05-4) unstable; urgency=medium

  * Make openscad-testrun default to run tests in parallel.
  * Limit --parallel build based on available memory (Closes: #945162).
  * Fix build with newer boost library (Closes: #977225).
  * Clean up some lintian warnings.

 -- Kristian Nielsen <knielsen@knielsen-hq.org>  Sat, 26 Dec 2020 14:21:30 +0100
