=== debian/control ===
Source: openscad
Priority: optional
Maintainer: Kristian Nielsen <knielsen@knielsen-hq.org>
Uploaders: Christian M. Amsüss <chrysn@fsfe.org>
# libcgal-qt5-dev is a workaround for http://bugs.debian.org/804539
Build-Depends:
    debhelper-compat (= 13),
    qt5-qmake,
    qtbase5-dev (>= 5.4),
    libcgal-qt5-dev,
    libcgal-dev (>=4.9),
    libopencsg-dev (>=1.3.0),
    libqscintilla2-qt5-dev,
    qtmultimedia5-dev,
    libfreetype6-dev,
    libfontconfig1-dev,
    libharfbuzz-dev,
    libeigen3-dev,
    libglib2.0-dev,
    libxml2-dev,
    libzip-dev,
    libcairo2-dev,
    lib3mf-dev,
    libspnav-dev,
    libqt5gamepad5-dev,
    bison (>= 2.4),
    flex (>=2.5.35),
# workaround for https://github.com/openscad/openscad/issues/1543
    libqt5opengl5-dev,
    libglew-dev (>= 1.5.4) | libglew1.6-dev | libglew1.5-dev (>= 1.5.4),
    libgmp-dev | libgmp10-dev | libgmp3-dev,
    libmpfr-dev,
    python3:any,
    cmake,
    libboost-dev (>= 1.46.0),
    libboost-regex-dev,
    libboost-system-dev,
    libboost-filesystem-dev,
    pkg-config,
    imagemagick (>= 6.5.9.3),
    libgl1-mesa-dri,
    xvfb,
    libgl1-mesa-dev,
    openscad-mcad,
    fonts-hosny-amiri,
    libdouble-conversion-dev,
# Needed for test suite
    ghostscript,
    unzip
# openscad is not gles compatible yet. this line makes builds abort before they
# faile at compile time. libqt5opengl5 uses gles on arm{el,hf}, making openscad
# currently unbuildable there. tracked upstream as
# https://github.com/openscad/openscad/issues/292 and in debian as
# http://bugs.debian.org/797816
Build-Conflicts:
    libgles2-mesa-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Section: graphics
Homepage: http://openscad.org/
Vcs-Browser: https://salsa.debian.org/knielsen-guest/openscad
Vcs-Git: https://salsa.debian.org/knielsen-guest/openscad.git -b master

Package: openscad
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends}
Recommends:
    openscad-mcad
Suggests:
    meshlab,
    geomview,
    librecad,
    openscad-testing
Description: script file based graphical CAD environment
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 OpenSCAD is not an interactive modeller. Instead it is something like a
 3D-compiler that reads in a script file that describes the object and renders
 the 3D model from this script. This gives the designer full control over the
 modelling process and enables him to easily change any step in the modelling
 process or make designes that are defined by configurable parameters.

Package: openscad-testing
Architecture: any
# the versioned imagemagick dependency stems from https://github.com/openscad/openscad/issues/1360
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad,
    openscad-testing-data,
    python3 (>= 3.5~),
    cmake,
    imagemagick (>= 6.5.9.3),
    xserver-xorg-core | xvfb,
    xauth,
    ghostscript,
    unzip,
    libgl1-mesa-dri
Description: script file based graphical CAD environment (test suite)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains all programs required to run the test suites.

Package: openscad-testing-data
Architecture: all
Multi-Arch: foreign
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    openscad-mcad,
    fonts-hosny-amiri
# the examples, which are shipped in openscad, are part of the test suite
Recommends: openscad
Suggests: openscad-testing
Description: script file based graphical CAD environment (test suite data)
 OpenSCAD is a software for creating solid 3D CAD objects. It focuses on CAD
 aspects rather than artistic ones.
 .
 This package contains the data required to run the test suites.
